local EJOYSDK_CONFIG = {
    lang = 'CN',
    zone = 'CN',
    default_lang = 'CN',
    os = 'ios',
    id = 'https://id.ejoy.com',
    http_dns = false,
}

local M = {}
M.DOMAIN_BASE = '.ejoy.com'   -- 留给以后hack

local all_service_normal = {
    {'launcher', 'https'},
    {'trace', 'https'},
    {'gangplank', 'https'},
    {'holo', 'https'},
    {'cs', 'https'},
    {'holo-cdn', 'http'},
}

local all_service_backup = {
    {'launcher', 'http'},
    {'trace', 'http'},
    {'gangplank', 'http'},
    {'holo', 'http'},
    {'cs', 'http'},
    {'holo-cdn', 'http'},
}

local all_service = all_service_normal

function M.set_service_backup()
    all_service = all_service_backup
end


function M.autoconfig(env, product)
    if type(env) == 'string' and type(product) == 'string' then
        EJOYSDK_CONFIG.product = product
        EJOYSDK_CONFIG.env = env
    elseif type(env) == 'table' and product == nil then
        local opt = env
        env = opt.env
        product = opt.product
        for k, v in pairs(opt) do
            EJOYSDK_CONFIG[k] = v
        end
    else
        assert(nil, "error config option")
    end

    local prefix
    if EJOYSDK_CONFIG.env == 'product' then
        prefix = product
    else
        prefix = EJOYSDK_CONFIG.env .. product
    end

    for _, v in ipairs(all_service) do
        local service, scheme = table.unpack(v)
        local url_base = scheme .. '://' .. prefix .. '-' .. service .. M.DOMAIN_BASE
        url_base = url_base:lower()

        EJOYSDK_CONFIG[service] = url_base
    end

    if env == 'test' then
        -- holo cdn 特殊处理一下
        EJOYSDK_CONFIG['holo-cdn'] = "http://test" .. product .. "-holo-origin.ejoy.com"
        EJOYSDK_CONFIG['id'] = 'https://testid.ejoy.com'
    end
end

function M.set_config(key, value)
    EJOYSDK_CONFIG[key] = value
end

function M.get_config(key)
    return EJOYSDK_CONFIG[key]
end

return M
