local byte = string.byte
local char = string.char

local M = {}

-- 一个简单的XOR流加解密器
local XORCipher = {}
XORCipher.__index = XORCipher

function XORCipher.new(key)
    return setmetatable({key=key, now=0}, XORCipher)
end

function XORCipher:encrypt(data)
    local key = self.key
    local key_len = #key
    local now = self.now

    local ret = {}
    for i=1, #data do
        now = now + 1
        ret[i] = char(byte(data, i) ~ byte(key, now))
        now = now % key_len
    end
    self.now = now
    return table.concat(ret)
end

XORCipher.decrypt = XORCipher.encrypt

M.XORCipher = XORCipher

return M
