local E = require "ejoysdk_lua.ejoysdk"
local ET = require "ejoysdk_lua.ejoysdk_topic"
local EG = require "ejoysdk_lua.ejoysdk_gangplank"
local ER = require "ejoysdk_lua.ejoysdk_resource"

local UNI = require "ejoysdk_lua.vendors.unisdk"
local Vendor = require "ejoysdk_lua.vendors.vendor"

local CHANNEL = "ALIPAY"
local listener = nil
local inited = false
local product_infos = {}

local M = Vendor:Inherit(CHANNEL)

local login_handler = function()
    if inited then
        return
    end

    _ejoysdk.log("get alipay info")

    EG.product_infos_base(CHANNEL, function(succ, infos)
        if succ then
            product_infos = infos
            E.log(product_infos)

            inited = true
            ET.publish('purchase_inited', CHANNEL)
        else
            _ejoysdk.log("log alipay product info fail")
        end
    end)
end

function M.init(opt)
    listener = opt.pay_listener
    ET.subscribe('login', login_handler)
    _ejoysdk.log("init ALIPAY")

    UNI.register_pay_listener(CHANNEL, function(succ, order_id, _ext_params)
        if succ then
            listener(succ, order_id)
        else
            listener(succ)
        end
    end)
end

function M.can_pay()
    return inited
end

function M.pay(product_id, _count, order_id, body)
    if not M.can_pay() then
        ET.publish('purchased', false, ER.order.CANT_PURCHASE)
    end

    assert(product_infos[product_id], "product_id " .. tostring(product_id) .. " not found")

    local order_info = body.cb

    UNI.pay(CHANNEL, order_id, {orderInfo = order_info})
end

function M.product_list()
    return product_infos
end

M:is_implemented({"PAY"})

return M
