local E = require "ejoysdk_lua.ejoysdk"
local JSON = require "ejoysdk_lua.ejoysdk_json"
local M = {}

local GOOGLE_LOGIN_EVENT = "GOOGLE_LOGIN_EVENT"
local IVK_GOOGLE_LOGIN = 'GOOGLE_LOGIN'
local IVK_GOOGLE_LOGOUT = 'GOOGLE_LOGOUT'

local G_LOGIN = 1

local login_info = nil
local login_cb = nil

function M.login(cb)
    login_cb = cb
    E.invoke(IVK_GOOGLE_LOGIN, {})
end

function M.logout(cb)
    login_info = nil
    E.invoke(IVK_GOOGLE_LOGOUT, {})
    cb()
end

function M.get_info()
    return login_info
end

function M.get_token()
    if login_info then
        return login_info.token
    end
end

local function on_login(succ, info)
    if succ then
        login_info = info
    end
    if login_cb then
        login_cb(succ, login_info)
        login_cb = nil
    end
end

local event_dispatch = {
    [G_LOGIN] = function(value)
        if value.succ then
            E.log(value)
            local info = {
                token = value.token,
                pid = value.pid,
                name = value.displayed_name,
            }
            on_login(true, info)
        else
            on_login(false)
        end
    end
}

_ejoysdk.register_cb(GOOGLE_LOGIN_EVENT, function(cbid, js_str, chunk)
    local handler = event_dispatch[cbid]
    if handler then
        local value = JSON:decode(js_str)
        handler(value, chunk)
    end
end)

return M
