local UNI = require "ejoysdk_lua.vendors.unisdk"
local Vendor = require "ejoysdk_lua.vendors.vendor"

local CHANNEL = "TESTSDK"
local auth_listener = nil
local g_outsource = nil
local g_info = nil

local M = Vendor:Inherit(CHANNEL)

function M.init(opt)
    auth_listener = opt.auth_listener
    UNI.register_login_listener(CHANNEL, function(succ, info, _ext_params)
        if succ then
            g_outsource = {
                platform = info.channel,
                ptoken = info.token,
                pid = info.pid,
                guest = false,
                with = nil,
                with_account = nil,
            }
            g_info = {
                app_name = info.channel_product_code,
            }
            auth_listener(succ, g_outsource, g_info)
        else
            auth_listener(succ)
        end
    end)
end

function M.login()
    if g_outsource then
        auth_listener(true, g_outsource, g_info)
    else
        UNI.login(CHANNEL)
    end
end

function M.logout(cb)
    g_outsource = nil
    g_info = nil
    UNI.logout(CHANNEL)
    cb()
end

function M.merge_info(info, pinfo)
    return M.merge_helper(info, pinfo)
end

function M.simple_token()
    return true
end

function M.check_token(outsource, info)
    auth_listener(true, outsource, info)
end

M:is_implemented({'ACCOUNT'})

return M
