local Class = require "ejoysdk_lua.ejoysdk_class"

local M = Class:Inherit('Vendor')
do
    local method = {
        ACCOUNT = {
            'check_token',      -- check_token(outsource, info)
            'merge_info',       -- merge_info(login_info, gangplank_retruned_info) -> info
            'simple_token',     -- simple_token() -> boolean
            'login',            -- login()
            'logout',           -- logout()
        },
        PAY = {
            'pay',
            'can_pay',
            'product_list',
        },
        SHARE = { },
        AD = { },
        PUSH = {
            'register',                 -- register(player_id)
            'add_local_notification',   -- add_local_notification(title, content, date, hour, min)
        },
    }

    for type_, l in pairs(method) do
        for _, v in ipairs(l) do
            M[v] = function()
                assert(false, type_ .. '/' .. v .. ' unimplemented')
            end
        end
    end

    function M:is_implemented(types)
        self.ability = types
        for _, type_ in ipairs(types) do
            local l = method[type_]
            for _, v in ipairs(l) do
                assert(rawget(self, v),
                'vendor ' ..  self.__ClassType__ .. ': '.. type_ .. '/' .. v .. ' unimplemented')
            end
        end
    end

    function M.merge_helper(a, b)
        local new = {}
        for k, v in pairs(a) do
            new[k] = v
        end
        for k, v in pairs(b) do
            new[k] = v
        end
        return new
    end
end

M.ABILITY = {
    ACCOUNT = 'ACCOUNT',
    PAY = 'PAY',
    SHARE = 'SHARE',
    AD = 'AD',
    PUSH = 'PUSH',
}

return M
