local EG = require "ejoysdk_lua.ejoysdk_gangplank"
local UNI = require "ejoysdk_lua.vendors.unisdk"
local Vendor = require "ejoysdk_lua.vendors.vendor"

local CHANNEL = "XG"

local ASYNC_REGISTER_PUSH = "ASYNC_REGISTER_PUSH"
local CAST_SET_TAG = "CAST_SET_TAG"
local CAST_DEL_TAG = "CAST_DEL_TAG"
local CAST_ADD_LOCAL_NOTIFICATION = "CAST_ADD_LOCAL_NOTIFICATION"
local SYNC_GET_PUSH_TOKEN = "SYNC_GET_PUSH_TOKEN"

local M = Vendor:Inherit(CHANNEL)

function M.init(_opt)
end

function M.register(player_id, cb)
    local uid = EG.user_info().uid
    local account = uid .. ':' .. tostring(player_id)
    _ejoysdk.log("Register TPUSH :" .. account)
    UNI.async_call(CHANNEL, ASYNC_REGISTER_PUSH, {account = account}, nil, cb)
end

function M.add_local_notification(title, content, date, hour, min)
    UNI.cast(CHANNEL, CAST_ADD_LOCAL_NOTIFICATION, {
            title = title,
            content = content,
            date = date,
            hour = hour,
            min = min,
        })
end

function M.set_tag(tag)
    UNI.cast(CHANNEL, CAST_SET_TAG, {tag = tag}, nil)
end

function M.del_tag(tag)
    UNI.cast(CHANNEL, CAST_DEL_TAG, {tag = tag}, nil)
end

function M.get_push_token()
    return UNI.sync_call(CHANNEL, SYNC_GET_PUSH_TOKEN, {}).body
end

M:is_implemented({"PUSH"})

return M
